<?php

namespace Modules\Sd\Http\Controllers;

use Illuminate\Contracts\Support\Renderable;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;
use Modules\Sd\Entities\PackingSlip;

class PackingSlipController extends Controller
{

    public function savePackingSlip(Request $request)
    {
        try {
            $packing_slip = new PackingSlip();
            $packing_slip->customer_order_id = $request->get('customer_order_id');
            $packing_slip->factory_po = $request->get('factory_po');
            $packing_slip->shipment_id = $request->get('shipment_id');
            $packing_slip->no_of_pallet = $request->get('pallet');
            $packing_slip->note = $request->get('note');
            $status  = $packing_slip->save();
            $responseBody = $this->responseBody(true, "PackingSlipController", "savePackingSlip", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingSlipController", "savePackingSlip", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    public function getPackingSlipData($id)
    {
        try {
            $packing_slip = PackingSlip::find($id);
            $responseBody = $this->responseBody(true, "PackingSlipController", "getPackingSlipData", $packing_slip);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingSlipController", "getPackingSlipData", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }




    public function updatePackingSlip(Request $request,$id)
    {
        try {
            $packing_slip = PackingSlip::find($id);
            $packing_slip->customer_order_id = $request->get('customer_order_id');
            $packing_slip->factory_po = $request->get('factory_po');
            $packing_slip->shipment_id = $request->get('shipment_id');
            $packing_slip->no_of_pallet = $request->get('pallet');
            $packing_slip->note = $request->get('note');
            $status  = $packing_slip->update();
            $responseBody = $this->responseBody(true, "PackingSlipController", "updatePackingSlip", $status);
        } catch (\Exception $exception) {
            $responseBody = $this->responseBody(false, "PackingSlipController", "updatePackingSlip", $exception);
        }
        return response()->json(["data" => $responseBody]);
    }


    /**
     * responseBody
     * This is used to create response.
     * @param success This is the paramter require boolean
     * @param name This is the paramter require ui table name
     * @param message This is the paramter require message content
     * @param result This is the paramter require result as some of data to return client
     * @return Json This returns as response.
     */
    private function responseBody($success, $name, $message, $result)
    {
        $body = [
            "success" => $success,
            "message" => $message,
            "name" => $name,
            "result" => $result
        ];
        return $body;
    }
}
